# Listbox w
# Transmit listbox
# Arguments:
#    w -	Name to use for new top-level window.
#
set opt_list_repeat 1
#
# Initiate the transmit server
proc initserver { w index rate} {
	global transmitname locktransmit opt_list_repeat
#	puts stderr "$w $index $rate"
 	 immserv $index $opt_list_repeat $rate
	set transmitname $index
	set locktransmit 1
#	$w.butframe.quit invoke
}
#
# write the listbox entries to imm.def file
proc writefile {listbox} {  	
    set fio [open "~/.imm.def" w]	
    for {set boxsize 0} {$boxsize < [$listbox size]} {incr boxsize} {
	set line [$listbox get $boxsize]
	if { [llength $line] == 0} continue
	if {[file isdirectory $line] == 0} continue
	puts $fio $line
    }	
    close $fio
}

# Create a dialog box.  Takes three or more arguments.  The first is
# the name of the window to use for the dialog box.  The second is a set
# of arguments for use in creating the message of the dialog box.  The
# third and following arguments consist of two-element lists, each
# describing one button.  The first element gives the text to be displayed
# in the button, the second gives the command to be invoked when the
# button is invoked.
proc mkDialog {w msgArgs args} {
    catch {destroy $w}
    toplevel $w -class Dialog
    set oldFocus [focus]
 
# Create two frames in the main window. The top frame will hold the
# message and the bottom one will hold the buttons.  Arrange them
# one above the other, with any extra vertical space split between
# them.
    frame $w.top -relief raised -border 1
    frame $w.bot -relief raised -border 1
    pack append $w $w.top {top fill expand} $w.bot {top fill expand}
    
# Create the message widget and arrange for it to be centered in the
# top frame.
    eval message $w.top.msg -justify center \
          -font -Adobe-times-medium-r-normal--*-180* $msgArgs
    pack append $w.top $w.top.msg {top expand padx 5 pady 5}
    
# Create as many buttons as needed and arrange them from left to right
# in the bottom frame.  Embed the left button in an additional sunken
# frame to indicate that it is the default button, and arrange for that
# button to be invoked as the default action for clicks and returns in
# the dialog.
 
    if {[llength $args] > 0} {
      set arg [lindex $args 0]
      frame $w.bot.0 -relief sunken -border 1
      pack append $w.bot $w.bot.0 {left expand padx 20 pady 20}
      button $w.bot.0.button -text [lindex $arg 0] \
              -command "[lindex $arg 1]; catch {destroy $w}; focus $oldFocus"
      pack append $w.bot.0 $w.bot.0.button {expand padx 12 pady 12}
      bind $w <1> "$w.bot.0.button config -relief sunken"
      bind $w <ButtonRelease-1> \
              "catch {destroy $w}; focus $oldFocus"
bind $w <Return> "[lindex $arg 1]; catch {destroy $w}; focus $oldFocus"
      focus $w
 
      set i 1
      foreach arg [lrange $args 1 end] {
          button $w.bot.$i -text [lindex $arg 0] \
                  -command "[lindex $arg 1];focus $oldFocus"
	  #                  -command "[lindex $arg 1]; catch {destroy $w}; focus $oldFocus"
          pack append $w.bot $w.bot.$i {left expand padx 20}
          set i [expr $i+1]
      }
    }
}
#
# Ask for directory entry
proc mkForm {{w .form}} {
    frame $w.directory
    entry $w.directory.entry -relief sunken -width 40
    bind $w.directory.entry <Return> "$w.enter invoke"
    label $w.directory.label -text "Directory"
    pack append $w.directory \
	$w.directory.entry right \
	$w.directory.label left 	
    focus $w.directory.entry	
    button $w.enter -text "Enter entry into table" \
	-command "$w.frame.list insert 0 \[$w.directory.entry get\]; \
		writefile $w.frame.list; \
		destroy $w.directory; \
		destroy $w.enter"

    pack append $w $w.directory {bottom fillx} \
	$w.enter {bottom fill}
}	 	
#
#
# make the transmit listbox
proc mkListbox2 {{w .l2}} {
    global opt_list_repeat	 
    catch {destroy $w}
    toplevel $w
    wm title $w "Transmit"
    wm iconname $w "Transmit"
    wm minsize $w 1 1
    frame $w.frame -borderwidth 10
    scrollbar $w.frame.scroll -relief sunken -command "$w.frame.list yview"
    listbox $w.frame.list -yscroll "$w.frame.scroll set" -relief sunken \
	    -setgrid 1 -width 50
    pack append $w.frame $w.frame.scroll {right filly} \
	    $w.frame.list {left expand fill}
    if {[file readable "~/.imm.def"] == 1 } {
	set fio [open "~/.imm.def" r]
	while { [gets $fio line] != -1} {
		$w.frame.list insert 0 $line
	}
	close $fio
    }	
    bind $w.frame.list <Double-1> \
	"mkServer $w \[lindex \[selection get\] 0\]"

    frame $w.butframe -borderwidth 10
    button $w.butframe.quit -text dismiss -command "destroy $w"
    button $w.butframe.start -text start -command \
	"mkServer $w \[lindex \[selection get\] 0\]"
    button $w.butframe.create -text create -command "mkForm $w"
    button $w.butframe.delete -text delete -command \
	"$w.frame.list delete \[$w.frame.list curselection\]; \
	writefile $w.frame.list"
    pack append $w.butframe $w.butframe.quit {left padx 4 } \
	$w.butframe.start {left padx 4} \
	$w.butframe.create {left padx 4} \
	$w.butframe.delete {left padx 4}
    pack append $w $w.frame {top expand filly frame center} \
	$w.butframe {bottom fillx}
}





