# mkRadio
# Various Button Options for IMM
#
# Arguments:
#    w -	Name to use for new top-level window.

set opt_dither 0
set opt_smooth 0
set opt_noreset 0
set viewlock 1
set transmitname "Transmit"
set postProcFile "PostProcessor"

# Ask for directory entry
proc mkPostProcess {{w .form}} {
    global postProcFile
    frame $w.postProc
    entry $w.postProc.entry -relief sunken -width 40 -textvariable postProcFile
    label $w.postProc.label -text "Post Processor Executable"
    pack append $w.postProc \
        $w.postProc.entry right \
        $w.postProc.label left 
    focus $w.postProc.entry
    pack append $w $w.postProc {bottom fillx}
}        


proc mkRadio {{w .r1}} {
    global opt_size opt_normalize opt_smooth locktransmit version \
	transmitname viewlock postProcFile
    catch {destroy $w}
    toplevel $w
    wm title $w "$version - Options"
    wm iconname $w "IMM Options"
    frame $w.frame -borderwidth 5
    pack append $w.frame \
	[frame $w.frame.left -borderwidth 2 -relief sunken] {left expand padx 2m} \
	[frame $w.frame.right -borderwidth 2 -relief sunken] {left expand padx 2m} \
	[frame $w.frame.trans -borderwidth 2 -relief sunken] {right expand padx 2m}
    pack append $w.frame.left \
	[radiobutton $w.frame.left.b1 -text "Default Screen" -variable opt_size \
	-relief flat -value -1 -anchor w] {fillx} \
	[radiobutton $w.frame.left.b2 -text "Tiled Screen" -variable opt_size \
	    -relief flat -value 0 -anchor w] {fillx} \
	[radiobutton $w.frame.left.b3 -text "Full Screen" -variable opt_size \
	    -relief flat -value 5 -anchor w] {fillx} \
	[radiobutton $w.frame.left.b5 -text "Window" -variable opt_size \
	    -relief flat -value 10 -anchor w] {fillx} \
	[radiobutton $w.frame.left.b4 -text "Archive" -variable opt_size \
	    -relief flat -value 11 -anchor w] {fillx} \
	[radiobutton $w.frame.left.b6 -text "$postProcFile" -variable opt_size \
	    -relief flat -value 12 -anchor w -command "mkPostProcess $w"] {fillx}
#	    -relief flat -value 12 -anchor w -command "$w.frame.trans.info configure -state disabled"] {fillx}
    pack append $w.frame.right \
     [checkbutton $w.frame.right.b1 -text "Dither" -variable opt_dither \
          -relief flat -anchor w] {fillx} \
      [checkbutton $w.frame.right.b2 -text "Smooth" -variable opt_smooth \
          -relief flat -anchor w] {fillx} \
      [checkbutton $w.frame.right.b3 -text "Debug" -command  "debug_proc" \
          -relief flat -anchor w] {fillx} \
      [checkbutton $w.frame.right.b4 -text "Noreset" -variable opt_noreset \
          -relief flat -anchor w] {fillx}
    pack append $w.frame.trans \
      [button $w.frame.trans.send -text $transmitname -command "mkListbox2 $w"] \
          {fill} \
      [button $w.frame.trans.info -text Viewers -command "mkViewbox2 $w"] \
          {top expand fill} \
      [button $w.frame.trans.log -text Log -command "mkLogbox2 $w"] \
          {top expand fill} \
      [button $w.frame.trans.host -text MyName -command "mkHostname $w"] \
          {top expand fill} \
      [button $w.frame.trans.clear -text Default -command "exec xv -root -clear &"] \
          {bottom expand fill}
    if { [info exists viewlock] == 0} {
        $w.frame.trans.info configure -state disabled}
    frame $w.frame2	
    pack append $w.frame2 \
      [button $w.frame2.ok -text OK -command "destroy $w"] \
          {left expand fill}
     pack append $w $w.frame {top expand fill} \
          $w.frame2 {bottom fill} 
}


