/******************************************************************************
  IMM version 3.0
  Written by Winston Dang <wkd@hawaii.edu>
  
  * Copyright (c) University of Hawaii 1993. All rights reserved.
  *  
  * License is granted to copy, to use, and to make and to use derivative
  * works for research, educational, government or evaluation purposes, provide
  * that the University of Hawaii is acknowledged in all documentation pertainin
  * to any such copy or derivative work. University of Hawaii grants no other 
  * licenses expressed or implied. The University of Hawaii trade name should 
  * not be used in any advertising without its written  permission.
  *  
  * UNIVERSITY OF HAWAII MAKES NO REPRESENTATIONS CONCERNING EITHER THE
  * MERCHANTABILITY OF THIS SOFTWARE OR THE SUITABILITY OF THIS SOFTWARE
  * FOR ANY PARTICULAR PURPOSE.  The software is provided "as is" without
  * express or implied warranty of any kind.
  *  
  * These notices must be retained in any copies of any part of this software.
  *****************************************************************************/
/*
 * Portions of this code were written by Joe Macker,  1996
 */
#include <stdio.h>
#include <signal.h>
#include <string.h>
#include "protocol.h"

#define TRUE 1
#define FALSE 0

char DEFAULT_PORT[] = "37793";
char DEFAULT_HOST[] = "224.2.158.99";

extern int debug;
extern SIG_T abortimage();
extern int newmember();
extern int closeall();

extern FILE *logfp;
extern char *OpenRecvFD();
extern void RecData();
extern int err_in_block;

/* Command-line options: */
char *display = NULL;
char *name = NULL;
char *portnum = NULL;
char *hostname = NULL;
char *title;
char *timetolive = NULL;
char *archfile = NULL;
char *imm2xv = NULL;
char *logname = NULL;
char *userstring = NULL;
extern int debug;
extern u_char ttl;
extern char *immdirectory;
int archfilenum = 2;
int serverid = 0;
int locktransmit = 0;
char *useimageloader = NULL;
char *localhost = NULL;

/*
 *----------------------------------------------------------------------
 * main --
 *----------------------------------------------------------------------
 */

int
main(argc, argv)
    int argc;				/* Number of arguments. */
    char **argv;			/* Array of argument strings. */
{
    /* Parse command-line arguments. */
    initialize(argc,argv);
    if ((portnum == NULL) || (hostname == NULL)) {
        portnum = DEFAULT_PORT;
        hostname = DEFAULT_HOST;
    }
    if (timetolive != NULL)
        ttl = atoi(timetolive);
    if (archfile != NULL)
        archfilenum = atoi(archfile);
    /* define the log file */
    logfp = stdout;
    if (logname != NULL) {
	logfp = fopen(logname,"w");
	if (debug) printf("log file %s\n",logname);
    }

    if (debug) printf("init Receiver\n");
    OpenRecvFD(portnum,hostname,archfilenum);

    newmember(10);

    for (;;) RecData(0,0);
    abortimage();
}

/******************************************************************************/
/* move the scale slider */
int scaleset(position)
int position;
{
}
/******************************************************************************/
/* move the scale slider */
int memberadd(user,ipaddress,good,bad,retries,packets)
char *user;
char *ipaddress;
unsigned short good;
unsigned short bad;
unsigned short retries;
unsigned short packets;
{
}
/******************************************************************************/
/* move the scale slider */
int serveradd(user,filename)
char *user;
char *filename;
{
}

/******************************************************************************/
/* set the button text in the main window */
int buttset(opt,desc, receiver)
int opt;
char *desc;
char *receiver;
{
}

/******************************************************************************/
/* build the xv options in the system call */
int build_xvopts(viewtype,line)
int viewtype;
char *line;
{
}

/******************************************************************************/
/* read the configuration file */
int initialize(argc, argv)
int argc;
char *argv[];
{
    int i=0;
    
    i = 1;
    while (i < argc) {
	if (*argv[i] == '-') {
	    switch (*(argv[i] + 1)) {
	    case 'd':
		i++;
		debug = atoi(argv[i]);
		break;
	    case 'p':
		/* take the port number */
		i++;
		portnum = argv[i];
		break;
	    case 'I':
	    case 'i':
		/* change the MULTICAST address */
		i++;
		hostname = argv[i];
		break;
#ifdef ERROR_TEST
	    case 'e':
		/* set number of simulated dropped packets */
		i++;
		err_in_block = atoi (argv[i]);
		break;
#endif
	    case 'l':
		i++;
		logname = argv[i];
		break;
	    case 'L':
		i++;
		localhost = argv[i];
		break;
	    case 't':
		i++;
		timetolive = argv[i];
		break;
	    case 'a':
		i++;
		archfile = argv[i];
		break;
	    case 'h':
		printf("imm [-d <debug level] [-p <port>] [-i <ip>] [-t <ttl>] [-h]\n");
		printf("ver %d Written by Winston Dang @copyright 1993 portions Joe Macker/Dang 1996)\n",
		       VERSION);
		exit(0);
	    }
	    i++;
	}
    }

}


