# mkHostname w
#
# Create a entry form for hostname to be used
# Arguments:
#    w -	Name to use for new top-level window.

proc reset_host {w name} {
	global hostname
	set hostname $name
	chgvarhost $name
	destroy $w
}

proc mkHostname {{w .form}} {
    global hostname
    catch {destroy $w}
    toplevel $w
    wm title $w "MyName"
    wm iconname $w "Form"
    message $w.msg -font -Adobe-times-medium-r-normal--*-180* -width 4i \
	    -text "Enter the name by which you want to be known to the world.  Click the \"OK\" button or type return when you're done."
    foreach i {f1} {
	frame $w.$i -bd 1m
	entry $w.$i.entry -relief sunken -width 40
	bind $w.$i.entry <Return> "reset_host $w \[$w.$i.entry get\]"
	label $w.$i.label
	pack $w.$i.entry -side right
	pack $w.$i.label -side left
    }
    $w.f1.label config -text MyName:
    $w.f1.entry insert 0 $hostname
    button $w.ok -text OK -command "reset_host $w \[$w.f1.entry get\]"
    pack $w.msg $w.f1 $w.ok -side top -fill x
    focus $w.f1.entry	
}

