set REPEAT 1
set DEBUG 0
set KRATE 25
set DELAY 60
set CURRENT 0
set MDU 1400

proc mkServer {w name} {
    global transmitname
    set transmitname $name
    catch {destroy $w}
    set w .server
    toplevel $w
    wm title $w "Image Multicast Server Tool"
    wm iconname $w "IMMSERVER"
    # positionWindow $w

    frame $w.menu -relief raised -bd 2
    pack $w.menu -side top -fill x

    set m $w.menu.options.m
    menubutton $w.menu.options -text "Options" -menu $m -underline 0
    menu $m
    $m add checkbutton -label "Send only updated files" -variable CURRENT
    $m add checkbutton -label "Continuous Repeat" -variable REPEAT
    $m add separator
    $m add command -label "Set MDU Size" -command setMDU

    set m $w.menu.cascade.m
    menubutton $w.menu.cascade -text "Debug" -menu $m -underline 0
    menu $m
    $m add cascade -label "Debug" \
	    -menu $w.menu.cascade.m.check -underline 0

    set m $w.menu.cascade.m.check
    menu $m
    $m add radio -label "OFF" -variable DEBUG -value 0
    $m add radio -label "Low Level" -variable DEBUG -value 2
    $m add radio -label "High Level" -variable DEBUG -value 9
    $m invoke 1
    
    

    pack $w.menu.options -side left
    pack $w.menu.cascade -side right

    # Make entries
    #vertically pack labels
    entry $w.entry3 -relief sunken -width 30 -textvariable transmitname 
    #vertically pack entry boxes
    pack  $w.entry3

    # make scale for rate entry
    scale $w.scale1 -width 10 -orient horizontal -variable KRATE \
	    -length 300 -from 0 -to 125 -tickinterval 25
    scale $w.scale2 -width 10 -orient horizontal -variable DELAY \
	    -length 300 -from 0 -to 60 -tickinterval 10

    label $w.label4 -width 20 -padx 20 -text "Transfer Rate (kbps)"
    label $w.label5 -width 20 -padx 20 -text "Timer Delay Interval (min)"
    pack $w.scale1 $w.label4 $w.scale2 $w.label5
    #horizontally pack columns
    button $w.transmit -background green -text "Transmit" -command {startserver}
    button $w.dismiss -background purple -text Dismiss -command {quitserver}
    pack $w.transmit $w.dismiss -side left -expand 1
}

proc startserver {} {
    #external variables have to be declared as "global"
    global KRATE DEBUG transmitname REPEAT DELAY CURRENT MDU
    set holdtime [expr $DELAY * 60]
    set brate [expr $KRATE * 1000]
    set rep [expr $REPEAT == 0]
    immserv -a -d $DEBUG -r $rep -s $brate -m $MDU -l $holdtime -o $CURRENT $transmitname
#puts "immserv -a -p PORT -i ADDRESS -d $DEBUG -r $rep -s $brate -l $holdtime -u $CURRENT $transmitname"
    destroy .server
}

proc quitserver {} {
    global transmitname
    set transmitname Transmit
    destroy .server
}

proc setMDU {{w .r1}} {
    global MDU
    catch {destroy $w}
    toplevel $w
    wm title $w "Set MDU"
    wm iconname $w "Set "
    wm minsize $w 1 1
    frame $w.frame -borderwidth 10
    label $w.frame.label -text "Enter MDU size:"
    entry $w.frame.ent -width 10 -textvariable MDU
    button $w.frame.quit -text dismiss -command "destroy $w"
    pack $w.frame $w.frame.label $w.frame.ent -side left
    pack $w.frame.quit -side bottom 
}
